//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//	Name:			   CF.c			                       					  //
//	Date:			   02/03/2004		                   					  //
//	Version:		   1.1											              //
//	Type:			   PIC C Driver for Compact Flash Card					  //
//	Author:        Mike Luck										           //
//	Company:		   MPIC3.COM										           //
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#include <input.c>

byte buffer[512];
int32 compactFlashPosition;

void CF_SetAddress(BYTE address){	// Set Address Bus:
	output_bit(CF_ADRESS_0,bit_test(address,0));
	output_bit(CF_ADRESS_1,bit_test(address,1));
	output_bit(CF_ADRESS_2,bit_test(address,2));
}

int Read_CF(){		// Read in Data:
	unsigned int Data;
	output_low(CF_READ);		// Strobe Read Line
	Data=input_D();		// Read Data Bus
	output_high(CF_READ);
	return Data;
}

void WRITE_CF(BYTE Data){		// Write out Data:
	output_D(Data);
	output_low(CF_WRITE);		// Strobe Write Line
	output_high(CF_WRITE);
}

BYTE CF_ReadData(BYTE Address){		// Read CF Data:
	CF_SetAddress(Address);		// Set Address
	return Read_CF();		// Read Data
}

void WRITE_CF_DATA(BYTE Address,BYTE Data){		// Write CF Data:
	CF_SetAddress(Address);		// Set Address
	WRITE_CF(Data);		// Write Data
}

void compactFlashReadBuffer(int32 offset, int32 length){
   int32 i;
	for(i=compactFlashPosition;i<offset;i++){
   	compactFlashPosition++;
		CF_ReadData(0);
	}
   for(i=0;i<length;i++){
      compactFlashPosition++;
      buffer[i]=CF_ReadData(0);
	}
}

BOOLEAN Reset_CF(){		// Reset Compact Flash:
	WRITE_CF_DATA(6,0x06);		// Reset Command
	delay_ms(100);
	WRITE_CF_DATA(6,0x02);		// End Reset
	delay_ms(1);
	WRITE_CF_DATA(7,0xEC);		// Identify Drive Command
	delay_ms(1);
	if((CF_ReadData(0)+(256*CF_ReadData(0))==0x848A)) return TRUE;
	else return FALSE;
}
