//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//	Name:			   FAT 16.c		                       					  //
//	Date:			   18/06/2004		                   					  //
//	Version:		   1.1											              //
//	Type:			   PIC C FAT 16 Functions				 					  //
//	Author:        Mike Luck										           //
//	Company:		   MPIC3.COM										           //
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

int16 total_files=0;
int32 file_size=0;
int32 root;
int16 bytes_per_sector;
int sectors_per_cluster;

void get_sector(int32 sector){
	int32 i;
	int32 k=0;
	int32 a=0;
	int32 sectors=32;
	int32 heads=16;
	compactFlashPosition=0;
	a=heads*sectors;
	for(sector=sector;sector>=a;sector=sector-a)	k++;
	WRITE_CF_DATA(5,k>>8);			// write cylinder
	WRITE_CF_DATA(4,k);
	k=0;
	for(sector=sector;sector>=sectors;sector=sector-sectors) k++;
	WRITE_CF_DATA(3,sector+1);		// write sector
	WRITE_CF_DATA(6,k+0xA0);			// write head
	WRITE_CF_DATA(2,1);
	WRITE_CF_DATA(7,0x20);
	delay_us(200);		// Wait For Data
	compactFlashReadBuffer(0,512);
}

int32 read_boot_sector(){
	WRITE_CF_DATA(3,1);
	WRITE_CF_DATA(4,0);
	WRITE_CF_DATA(5,0);
	WRITE_CF_DATA(6,1+0xA0);
	WRITE_CF_DATA(2,1);
	WRITE_CF_DATA(7,0x20);
	delay_us(200);		// Wait For Data
	compactFlashReadBuffer(0,512);
	root=(buffer[16]*(make16(buffer[23],buffer[22])))+(make16(buffer[15],buffer[14]))+32;
	bytes_per_sector=make16(buffer[12],buffer[11]);
	sectors_per_cluster=buffer[13];

	WRITE_CF_DATA(7,0xEC);		// Identify Drive Command
	delay_ms(1);
	CF_ReadData(0);
	CF_ReadData(0);
	CF_ReadData(0);
	CF_ReadData(0);
	CF_ReadData(0);
	CF_ReadData(0);
	printf("heads=%lu",CF_ReadData(0)+(256*CF_ReadData(0)));		// Default Number of Heads
	CF_ReadData(0);
	CF_ReadData(0);
	CF_ReadData(0);
	CF_ReadData(0);
	printf("sectors/track=%lu",CF_ReadData(0)+(256*CF_ReadData(0)));		// Default Number of Sectors Per Track
}

int32 find_file(int16 file){
	int a=0;
	int16 fat_entry=0;
	int lfn=0;
	byte prev_lfn[128];
	int32 sector;
	int16 files=0;
	int32 s=0;
	s=root-1;
	while(TRUE){
		s++;
		get_sector(s);
		for(fat_entry=0;fat_entry<16;fat_entry++){
			if(buffer[(32*fat_entry)+11]==0) goto end_of_root;
			if(buffer[(32*fat_entry)+11]==0x20){ // Find a File
				if(buffer[(32*fat_entry)+8]=='M' || buffer[(32*fat_entry)+8]=='m'){
					if(buffer[(32*fat_entry)+9]=='P' || buffer[(32*fat_entry)+9]=='p'){
						if(buffer[(32*fat_entry)+10]=='3'){
							if(buffer[(32*fat_entry)]!=229){ // Don't show Deleted Files
								files++;
								if(files>total_files) total_files++;
								if(files==file){
									printf("\r%lu ",file);
									if((buffer[(32*fat_entry)+6])!='~')	for(loop=0;loop<8;loop++) printf("%C",buffer[(32*fat_entry)+loop]);
									else{
										for(lfn=1;lfn<5;lfn++){
											if(fat_entry>=lfn){
												for(loop=1;loop<11;loop++) printf("%C",buffer[(32*(fat_entry-lfn))+loop]);
												for(loop=14;loop<26;loop++) printf("%C",buffer[(32*(fat_entry-lfn))+loop]);
												for(loop=28;loop<31;loop++) printf("%C",buffer[(32*(fat_entry-lfn))+loop]);
												if(bit_test(buffer[(32*(fat_entry-lfn))],6)) lfn=100; // End of LFN
											}
											else{
												a++;
												for(loop=1;loop<11;loop++) printf("%C",prev_lfn[(128-(a*32))+loop]);
												for(loop=14;loop<26;loop++) printf("%C",prev_lfn[(128-(a*32))+loop]);
												for(loop=28;loop<31;loop++) printf("%C",prev_lfn[(128-(a*32))+loop]);
												if(bit_test(prev_lfn[(128-(a*32))],6)) lfn=100; // End of LFN
											}
										}
									}
									printf("            ");
									file_size=make32(buffer[(32*fat_entry)+31],buffer[(32*fat_entry)+30],buffer[(32*fat_entry)+29],buffer[(32*fat_entry)+28]);
									sector=make16(buffer[(32*fat_entry)+27],buffer[(32*fat_entry)+26]);
									sector=sector*sectors_per_cluster;
									sector=sector+bytes_per_sector;
									sector=sector+32;
									return sector;
								}
							}
						}
					}
				}
			}
		}
		if(buffer[491]==0x0F) for(loop=512;loop>384;loop--) prev_lfn[loop-384]=buffer[loop]; // Long Long file names can be longer than 4.
	}
end_of_root:;
return 0;
}
